//include std.inc
//include security.inc
//include log.inc
//include handler.inc
//include uris.inc

Module WBHandle

	Public Function NoAuthorization() As String
		Dim s As String
		
		s = "<body><h1>401 - Authorization failed.</h1><br>Please try again. If this problem continues happening, please contact your administrator!</body>"
		Return(s)
	End Function
	
	Public Function Handle(s As String) As String
		Dim sec As Security
		
		sec = New Security
		
		Select Case s
			Case "ShowGUI"
				ShowGUI()
				Return(GenerateMainPage())
			Case "UnloadHandler"
				UnloadHandler()
				Return(GenerateHandlerPage())
			Case "ShowHandlers"
				Return(GenerateHandlerPage())
			Case "ShowLog"
				Return(GenerateLogListing())
			Case "Quit"
				sec.Quit()
			Case "StopServer"
				sec.StopListening()
				Return(GenerateMainPage())
			Case "ReInitServer"
				sec.InitServer()
				Return(GenerateMainPage())
			Case "SetPassword"
				ApplyNewPassword()
				Return(GenerateMainPage())
			Case "PasswordPage"
				Return(GeneratePasswordPage())
			Else
				Return(GenerateMainPage())
		End Select
		
	End Function
	
	Private Sub ApplyNewPassword()
		Dim req As Request = New Request
		
		If ExecuteCMD("config ? /System/MainPassword") = "True" Then Call ExecuteCMD("config del /System/MainPassword")
		Call ExecuteCMD("config add /System/MainPassword::" + req.PostDataValue("newPassword"))
	End Sub
	
	Private Function GeneratePasswordPage() As String
		Dim s As String
			
		s = "<body bgcolor=""#cococo"">" + EOL //Begin
		
		s = s + "<h1>Webmin 1.0</h1><br>" + EOL //Title
		
		s = s + "<br><h3>Set Password...</h3><br>" + EOL
		s = s + "<form method=POST action=""" + req.Target + """><input type=""hidden"" name=""action"" value=""SetPassword"">"
		s = s + "Enter new password: <input type=""text"" name=""newPassword""><br><input type=""submit"" value=""Set""></form>" + EOL
		
		s = s + EOL + "</body>" //End
		
		Return(s)
	End Function

	
	Private Sub UnloadHandler()
		Dim req As Request = New Request
		Dim kill As Integer
		Dim hand As Handler
		
		If Not req.PostDataIsSet("no") Then Return
		
		kill = Val(req.PostDataValue("no"))
		If kill < HandlerCount() And kill > -1 Then
			hand = GetHandler(kill)
			hand.Unload()
			Log("Webmin: Handler #" + Str(kill) + ", named " + hand.Name() + " was unloaded.", "W")
		End If
	End Sub
		
	
	Private Function GenerateHandlerPage() As String
		Dim s As String
			
		s = "<body bgcolor=""#cococo"">" + EOL //Begin
		
		s = s + "<h1>Webmin 1.0</h1><br>" + EOL //Title
		
		s = s + "<br><h3>Handlers...</h3><br>" + EOL
		s = s + "<form method=POST action=""" + req.Target + """><input type=""hidden"" name=""action"" value=""UnloadHandler""><table border=""1"" width=""100%""><tr><td><b>Data</b></td><td><b>Unload</b></tr>" + EOL
		
		Dim i As Integer
		Dim hand As Handler
		
		For i = 0 To HandlerCount() - 1
			hand = GetHandler(i)
			
			s = s + "<tr><td>" + hand.Name() + "</td><td><input type=""submit"" name=""no"" value=""" + Str(i) + """></td></tr>" + EOL
		Next i
		
		s = s + "</table></form><br>Total: " + Str(HandlerCount()) + " entries" + EOL
		
		s = s + EOL + "</body>" //End
		
		Return(s)
	End Function
	
	Private Function GenerateLogListing() As String
		Dim s As String
			
		s = "<body bgcolor=""#cococo"">" + EOL //Begin
		
		s = s + "<h1>Webmin 1.0</h1><br>" + EOL //Title
		
		s = s + "<br><h3>Loglisting...</h3><br>" + EOL
		s = s + "<table border=""1"" width=""100%""><tr><td><b>Data</b></td><td><b>Date</b></td><td><b>P</b></td></tr>" + EOL
		
		Dim i As Integer
		Dim lI As LogItem
		
		For i = 0 To LogCount() - 1
			lI = Log(i)
			
			s = s + "<tr><td>" + lI.Date() + "</td><td>" + lI.Data() + "</td><td>" + lI.Priority() + "</td></tr>" + EOL
		Next i
		
		s = s + "</table><br>Total: " + Str(LogCount()) + " entries" + EOL
		
		s = s + EOL + "</body>" //End
		
		Return(s)
	End Function
	
	Private Function GenerateMainPage() As String
		Dim s As String
		Dim req As Request = New Request
		
		s = "<body bgcolor=""#cococo"">" + EOL //Begin
		
		s = s + "<h1>Webmin 1.0</h1><br>" + EOL //Title
		
		If req.PostDataIsSet("action") Then	s = s + "Last performed action: " + req.PostDataValue("action") + "<br>"
		
		s = s + "<br><h3>Security related tasks</h3><br><form method=""POST"" action=""" + req.Target + """>" + EOL
		
		s = s + "<table border=""1"" width=""100%""><colgroup><col width=""7*""><col width=""3*""></colgroup><tr><td><b>Description</b></td><td><b>Do</b></td></tr>" + EOL
		
		s = s + "<tr><td>Quits the whole server application</td><td><input type=""submit"" name=""action"" value=""Quit""></td></tr>" + EOL
		s = s + "<tr><td>Prevents the server from accepting new connections</td><td><input type=""submit"" name=""action"" value=""StopServer""></td></tr>" + EOL
		s = s + "<tr><td>Reenables the server if it was stopped</td><td><input type=""submit"" name=""action"" value=""ReInitServer""></td></tr>" + EOL		
		s = s + "</table>" + EOL
		
		s = s + "<br><h3>Various tasks</h3><br>"
		s = s + "<table border=""1"" width=""100%""><colgroup><col width=""7*""><col width=""3*""></colgroup><tr><td><b>Description</b></td><td><b>Do</b></td></tr>" + EOL
		s = s + "<tr><td>Shows the server log</td><td><input type=""submit"" name=""action"" value=""ShowLog""></td></tr>" + EOL
		s = s + "<tr><td>Sets/Adds the password</td><td><input type=""submit"" name=""action"" value=""PasswordPage""></td></tr>" + EOL
		s = s + "<tr><td>Shows the handlers</td><td><input type=""submit"" name=""action"" value=""ShowHandlers""></td></tr>" + EOL
		s = s + "<tr><td>Shows the GUI on the Host-System</td><td><input type=""submit"" name=""action"" value=""ShowGUI""></td></tr>" + EOL
		s = s + "<tr><td>Uptime</td><td>" + GetFormatedUptime() + "</td></tr>" + EOL
		s = s + "<tr><td>Timestamp</td><td>" + GetTime() + "</td></tr>" + EOL
		s = s + "<tr><td>Server</td><td>" + Version() + "</td></tr>" + EOL
		s = s + "<tr><td>Useragent</td><td>" + req.HeaderValue("User-Agent") + "</td></tr>" + EOL
		s = s + "<tr><td>HTTP-Authentication-User:</td><td>" + GetAuthUser() + "</td></tr>" + EOL
		s = s + "</table></form>" + EOL
		
		s = s + "<br><h3>ServiceURIs</h3><br>"
		
		Dim i As Integer
		s = s + "<table border=""1"" width=""100%""><colgroup><col width=""7*""><col width=""3*""></colgroup><tr><td><b>Description</b></td><td><b>Do</b></td></tr>" + EOL
		For i = 0 To ServiceURIs.Count() - 1
			s = s + "<tr><td>" + ServiceURIs.Get(i).Description + "</td><td><a href=""" + ServiceURIs.Get(i).URI + """>Call</a></td></tr>" + EOL
		Next i
		s = s + "</table>"
		
		s = s + EOL + "</body>" //End
		
		Return s
	End Function
	
	Private Function GetFormatedUptime() As String
		Dim totalSec, Secs, Mins, Hours, Days, Years As Double
  
		totalSec = GetUpTime() \ 1000000
  
		Years = totalSec \ 31536000
		totalSec = totalSec - (Years * 31536000)
  
		Days = totalSec \ 86400
		totalSec = totalSec - (Days * 86400)
  
		Hours = totalSec \ 3600
		totalSec = totalSec - (Hours * 3600)
  
		Mins = totalSec \ 60
		totalSec = totalSec - (Mins * 60)

		Secs = totalSec Mod 60
  
		Return Format(Years, "0") + ":" + Format(Days, "0") + ":" + Format(Hours, "00") + ":" + Format(Mins, "00") + ":" + Format(Secs, "00")
  
  End Function
	
End Module

Dim req As Request = New Request
Dim ans As Answer = New Answer

echo("<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01 Transitional//EN"" ""http://www.w3.org/TR/html4/loose.dtd"">")
echo("<html>")
echo("<head>")
echo("<meta http-equiv=""content-type"" content=""text/html; charset=UTF-8"">")
echo("<title>Webmin</title>")
echo("</head>")

If ExecuteCMD("config ? Root/System/MainPassword") = "False" Then Call ExecuteCMD("config add Root/System/MainPassword::")

If StrComp(GetAuthPasswd(), ExecuteCMD("config get Root/System/MainPassword"), 0) <> 0 Then
	ans.MIME = "text/html"
	ans.StatusCode = 401
	ans.HeaderAdd("WWW-Authenticate", "Basic realm=""Login to Webmin""")
	ans.StatusMessage = StatusMessage(ans.StatusCode())
	ans.HTTPVersion = req.HTTPVersion

	echo(WBHandle.NoAuthorization())
Else
	ans.MIME = "text/html"
	ans.StatusCode = 200
	ans.StatusMessage = StatusMessage(ans.StatusCode())
	ans.HTTPVersion = req.HTTPVersion
	
	echo(WBHandle.Handle(req.PostDataValue("action")))
End If

echo("</html>")