Class Request
	Function SourceIP() As String
		Return(RequestSourceIP())
	End Function
	
	Function HeaderCount() As Integer
		Return(RequestHeaderCount())
	End Function
	
	Function HeaderValue(i As Integer) As String
		Return(RequestHeaderValue(i))
	End Function
	
	Function HeaderValue(s As String) As String
		Return(RequestHeaderValue(s))
	End Function
	
	Function HeaderName(i As Integer) As String
		Return(RequestHeaderName(i))
	End Function
	
	Function HTTPVersion() As String
		Return(GetHTTPVersion())
	End Function
	
	Function Target() As String
		Return(RequestTarget())
	End Function
	
	Function PostDataCount() As Integer
		Return(RequestPostDataCount())
	End Function
	
	Function PostDataValue(i As Integer) As String
		Return(RequestPostDataValue(i))
	End Function
	
	Function PostDataValue(name As String) As String
		Return(RequestPostDataValue(name))
	End Function
	
	Function PostDataName(i As Integer) As String
		Return(RequestPostDataName(i))
	End Function
	
	Function PostDataIsSet(name As String) As Boolean
		Return(RequestPostDataIsSet(name))
	End Function
End Class

Module Std
	Function ExecuteCMD(cmd As String) As String
		Return(ServerCommandRun(cmd))
	End Function

	Sub ShowGUI()
		GUIDisplayMainWindow()
	End Sub

	Function GetMIME(filename As String) As String
		Return(PredefinedMIME(filename))
	End Function
	
	Sub echo(s As String)
		AnswerAddToContent(s)
	End Sub
	
	Sub echoLine(optional s As String = "")
		echo(s + EOL())
	End Sub
	
	Function GetTime() As String
		Return(ServerCurrentTime())
	End Function
	
	Function GetUptime() As Double
		Return(ServerUptime())
	End Function
	
	Function Version() As String
		Return(ServerVersion())
	End Function
	
	Function StatusMessage(status As Integer) As String
		Return(ServerPredefinedHTTPMesssage(status))
	End Function
	
	Function DecodeBase64(source As String) As String
		Return(GlobalDecodeBase64(source))
	End Function
	
	Function EncodeBase64(source As String) As String
		Return(GlobalEncodeBase64(source))
	End Function
End Module

Class Answer
	Sub MIME(Assigns newMIME As String)
		AnswerMIME = newMIME
	End Sub
	
	Function MIME() As String
		Return(AnswerMIME)
	End Function
	
	Function AllowCache() As Boolean
		Return(AnswerAllowCache())
	End Function
	
	Sub AllowCache(Assigns yesno As Boolean)
		AnswerAllowCache = yesno
	End Sub

	Sub HTTPVersion(Assigns data As String)
		AnswerHTTPVersion = data
	End Sub
	
	Function HTTPVersion() As String
		Return(AnswerHTTPVersion)
	End Function
	
	Function StatusCode() As Integer
		Return(AnswerStatusCode())
	End Function
	
	Sub StatusCode(Assigns s As Integer)
		AnswerStatusCode = s
	End Sub
	
	Sub StatusMessage(Assigns msg As String)
		AnswerHTTPMessage = msg
	End Sub
	
	Function StatusMessage() As String
		Return(AnswerHTTPMessage)
	End Function
	
	Function HeaderCount() As Integer
		Return(AnswerHeaderCount())
	End Function
	
	Sub HeaderAdd(name As String, value As String)
		AnswerHeaderAdd(name, value)
	End Sub
	
	Sub PurgeHeader()
		AnswerHeaderPurge()
	End Sub
	
	Sub RemoveHeader(name As String)
		AnswerHeaderRemove(name)
	End Sub
	
	Function HeaderName(index As Integer) As String
		Return(AnswerHeaderName(index))
	End Function
End Class
